unit PeriodicTableForm;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, element;

type
  TfPeriodTable = class(TForm)
    PaintBox1: TPaintBox;
    procedure PaintBox1Paint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Elements : TElements;
    Table : TPeriodicTable;
  end;

var
  fPeriodTable: TfPeriodTable;

implementation

{$R *.dfm}

uses ElementRenderer;

procedure TfPeriodTable.FormCreate(Sender: TObject);
begin
  Elements := TElements.Create;
  Table := TPeriodicTable.Create(Elements);
end;

procedure TfPeriodTable.PaintBox1Paint(Sender: TObject);
var
  I: Integer;
  j: Integer;
  r : TRect;
  c : TCanvas;
  w, h : integer;
  e : IElement;
begin
  c := PaintBox1.Canvas;
  w := PaintBox1.Width div 18;
  h := PaintBox1.Height div 9;

  for I := 0 to 17 do
  begin
    for j := 0 to 8 do
    begin
      r := Rect(i*w, j*h, i*w+w, j*h+h);
      e := Table.Element(i+1, j+1);
      DrawPeriodicTableCellBackground(Assigned(e), false, c, r);
      if Assigned(e) then
      begin
        c.Rectangle(r);
        DrawPeriodicTableCellContents(e, c, r);
      end;

    end;
  end;
end;

end.
